#!/usr/bin/python

"""
911tabs.py
This script opens Konqueror to find out tabs on 911tabs.com
about the played song or band in amaroK.
2005-11-21
Copyright 2005 &copy; Mike Massonnet <mike@massonnet.org>
License http://opensource.org/licenses/gpl-license.php GNU Public License
Version 0.0.2
"""

import os
import commands
import sys
import threading
import signal

try:
	from qt import *
except:
	os.popen( "kdialog --sorry 'PyQt (Qt bindings for Python) is required for this script.'" )
	raise

def searchSong():
	song = commands.getoutput("dcop amarok player title")
	url = "'http://www.911tabs.com/search.php?search="+song+"&type=song'"
	os.system("konqueror "+url+" &")

def searchBand():
	band = commands.getoutput("dcop amarok player artist")
	url = "'http://www.911tabs.com/search.php?search="+band+"&type=band'"
	os.system("konqueror "+url+" &")

class MainGui( QApplication ):
	
	def __init__(self, args):
		QApplication.__init__(self, args)
		
		signal.signal(signal.SIGTERM, self.clean)
		
		os.system('dcop amarok script addCustomMenuItem "911tabs" "Song"')
		os.system('dcop amarok script addCustomMenuItem "911tabs" "Band"')
		
		self.t = threading.Thread(target=self.readStdin)
		self.t.start()
	
	def clean(self):
		""" Called when the script is going to close"""
		os.system('dcop amarok script removeCustomMenuItem "911tabs" "Song"')
		os.system('dcop amarok script removeCustomMenuItem "911tabs" "Band"')
		self.quit()
	
	def readStdin(self):
		""" Catches the action from amaroK """
		while True:
			line = sys.stdin.readline()
			if line.find("customMenuClicked") > -1:
				# We can fetch the artist and title of the current track only
				# TODO find how to fetch id3tags from a url
				currentTrack = commands.getoutput('dcop amarok player encodedURL')
				if line.find(currentTrack) > -1:
					# Search for the song
					if line.find("customMenuClicked: 911tabs Song") > -1:
						searchSong()
					# Search for the band
					elif line.find("customMenuClicked: 911tabs Band") > -1:
						searchBand()
				elif line:
					os.system('dcop amarok playlist popupMessage "911tabs: ERROR The track is not playing"')
					self.text.append(line)
			elif line:
				continue
			else:
				self.clean()
				break;

def main(args):
	app = MainGui(args)
	app.exec_loop()

if __name__ == "__main__":
	main(sys.argv)

